

<template>
    <v-row align="center" justify="center">
        <v-col cols="12" align="center" justify="center">
            <v-card class="pa-2 ma-3">
                <v-card-title>{{ this.$t('share.importPeerDB') }}</v-card-title>
                <v-card-text>
                    <v-row>
                        <v-col cols="8">
                            <v-text-field
                                prepend-inner-icon="mdi-account-details-outline"
                                disabled
                                outlined
                                dense
                                :label="$t('share.myDatabaseID')"
                                v-model="state.localReceiptDB"
                            />
                        </v-col>
                        <v-col cols="4">
                            <v-btn icon @click="onCopy(state.localReceiptDB)"><v-icon>mdi-content-copy</v-icon></v-btn>
                            <v-btn icon @click="onMakeQR(state.localReceiptDB)"><v-icon>mdi-qrcode</v-icon></v-btn>
                        </v-col>
                            <v-text-field
                                v-model="state.peerId"
                                dense
                                outlined
                                clearable
                                type="text"
                                :label="$t('share.peerDatabaseID')"
                                prepend-inner-icon="mdi-account-multiple"
                                value=""
                            ></v-text-field>
                    </v-row>
                </v-card-text>
                <v-card-actions>
                    <v-btn
                        class="mx-2"
                        elevation="2"
                        color="primary"
                        @click="state.replicatePeerDataWSS"
                    >{{ $t('share.sync') }} WSS <v-icon>mdi-sync</v-icon></v-btn>
                    <v-btn
                        class="mx-2"
                        elevation="2"
                        color="primary"
                        @click="state.replicatePeerDataIPFS"
                    >{{ $t('share.sync') }} IPFS <v-icon>mdi-sync</v-icon></v-btn>
                </v-card-actions>
            </v-card>
            <v-dialog
                v-model="state.showProgress"
                width="500"
            >
                <v-card>
                    <v-card-title class="text-h5 grey lighten-2">
                        {{ $t('share.copying') }}
                    </v-card-title>

                    <v-card-text v-if="state.peerData">
                        <p>From Address: {{ state.peerData.address }}</p>
                        <!-- <p>Hash: {{ state.peerData.hash }}</p>
                             <p>Entry: {{ state.peerData.entry }}</p> -->
                        <p>Progress: {{ state.peerData.progress }} / {{ state.peerData.have }}</p>
                    </v-card-text>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn
                            color="primary"
                            text
                            @click="state.setShowProgress(false)"
                        >
                            {{ $t('share.doNotWait') }}
                        </v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>
            <v-dialog
                v-model="dialog"
                width="500"
            >
                <v-card>
                    <v-card-title class="text-h5 grey lighten-2">
                    {{ state.localReceiptDB }}
                    </v-card-title>

                    <v-card-text>
                        <v-img :src="`data:image/svg+xml;base64,${state.qrImage}`"/>
                    </v-card-text>
                    <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn
                        color="primary"
                        text
                        @click="dialog = false"
                    >
                        {{ $t('share.done') }}
                    </v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>
        </v-col>
    </v-row>
</template>

<script lang="ts">
import { Component, Inject, Vue } from 'vue-property-decorator'
import { Observer } from "mobx-vue";
import { RootStore } from "@/store"
import { ShareModel } from '@/store/modules/share';



@Observer
@Component({})
export default class Share extends Vue {

    @Inject("root") root !: RootStore
    public headers: Array<object> = [
        { text: "Peer id", value: "id" },
        { text: "Multiaddrs", value: "addr" }
    ]
    private state = new ShareModel(this.root)
    private dialog: boolean = false

    private onCopy(text: string) {
        navigator.clipboard.writeText(text);
    }
    private onMakeQR (id: string) {
        this.state.makeQR(id);
        this.dialog = true;
    }
}

</script>
